--- old/usr/src/uts/common/fs/nfs/nfs_vnops.c	Fri Jan 18 13:59:20 2013
+++ new/usr/src/uts/common/fs/nfs/nfs_vnops.c	Fri Jan 18 13:59:20 2013
@@ -25,6 +25,10 @@
  *	All rights reserved.
  */
 
+/*
+ * Copyright (c) 2013, Joyent, Inc. All rights reserved.
+ */
+
 #include <sys/param.h>
 #include <sys/types.h>
 #include <sys/systm.h>
@@ -2030,6 +2034,14 @@
 				    vp->v_type == VREG) {
 					vattr.va_mask = AT_SIZE;
 					error = nfssetattr(vp, &vattr, 0, cr);
+
+					if (!error) {
+						/*
+						 * Existing file was truncated;
+						 * emit a create event.
+						 */
+						vnevent_create(vp, ct);
+					}
 				}
 			}
 		}
@@ -2037,10 +2049,6 @@
 		if (error) {
 			VN_RELE(vp);
 		} else {
-			/*
-			 * existing file got truncated, notify.
-			 */
-			vnevent_create(vp, ct);
 			*vpp = vp;
 		}
 		return (error);
